﻿Imports Infragistics.Win
Imports Infragistics.Win.UltraWinGrid

Public Class Form1

    Dim state As CheckState
    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Dim data As DataTable = New DataTable
        data.Columns.Add("id", GetType(String)).AutoIncrement = True
        data.Columns.Add("bool", GetType(Boolean))
        data.Columns.Add("Text", GetType(String))

        For index = 1 To 10
            data.Rows.Add(Nothing, index Mod 3 = 0, String.Format("Text {0}", index))
        Next

        UltraGrid1.DataSource = data


    End Sub

    Private Sub UltraGrid1_ClickCell(sender As System.Object, e As Infragistics.Win.UltraWinGrid.ClickCellEventArgs) Handles UltraGrid1.ClickCell

        If TypeOf e.Cell.EditorResolved Is CheckEditor Then
            state = DirectCast(e.Cell.EditorResolved, CheckEditor).CheckState
        End If

    End Sub


    Private Sub UltraGrid1_CellChange(sender As System.Object, e As Infragistics.Win.UltraWinGrid.CellEventArgs) Handles UltraGrid1.CellChange
        If TypeOf e.Cell.EditorResolved Is CheckEditor Then
            Dim indicator As CheckIndicatorUIElement = e.Cell.GetUIElement().GetDescendant(GetType(CheckIndicatorUIElement))
            Dim gris As UltraGrid = sender
            If Not gris.DisplayLayout.UIElement.LastElementEntered.Equals(indicator) Then
                DirectCast(e.Cell.EditorResolved, CheckEditor).CheckState = state
            End If
        End If
    End Sub

End Class
